--[[The original loveanimation license is below here
I heavily modified the source for my needs and to work with Aseprite, and I have not cleaned my code of 
pointless comments and  uselesess stuff ^^ Is just as is.

About loveanimation I loved the simplicity and "sturdiness" that let me hammer the library with ease wihtout breaking it.

denis
--]]

--[[

The MIT License (MIT)

Copyright (c) 2013 Patrick Rabier

Permission is hereby granted, free of charge, to any person obtaining a copy of
this software and associated documentation files (the "Software"), to deal in
the Software without restriction, including without limitation the rights to
use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
the Software, and to permit persons to whom the Software is furnished to do so,
subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

]]

--
-- LOVE2D ANIMATION
--
-- @todo document
-- @todo error management
-- @todo the path in the animation file should be relative to the file's location
-- @todo more flexible events ?
-- @todo load an animation with an already loaded image
--

--
-- The animation class
-- Loads an animation file (containing a path to the image)
-- Check the animation file template for the format
--
-- @member filepath the path of the animation file
-- @member descriptor the object loaded from the file (describes the animation frames)
-- @member currentState the state the animation is in. Each state is a line in the image
-- @member currentFrame the frame (of the current state) the animation is displaying
-- @member tick the amount of time the current frame has been displayed
-- @member speedMultiplier a multiplier used to control the animation speed programatically
-- @member active whether the animation is running (or is paused)
-- @member texture the image loaded
-- @member x horizontal coordinate
-- @member y vertical coordinate
-- @member rotation rotation angle in radians
-- @member relativeOriginX the x origin as a multiplier of the sprite's width
--	(ex : 1 for right, 0 for left)
-- @member relativeOriginY the y origin as a multiplier of the sprite's height
-- @member visible boolean, whether the sprite is visible
--
--local loader = require "library.ase-loader"
require "library.aseprite"


lovease = {
	-- Members
    name = "",
    filepath = nil,
    type= "relative", --relative is drawn at the bottomcenter , --normal  at upleft corner, center at center
    descriptor = nil,
    currentState = nil,
    currentFrame = 1,
    tick = 0,
    speedMultiplier = 1,
    slideX = 0,
    slideY = 0,
    scaleX = 1,
    scaleY = 1,
    active = true,
    texture = nil,
    x = 0,
    y = 0,
    rotation = 0,
    relativeOriginX = 0,
    relativeOriginY = 0,
    visible = true,
    defaultState = "idle", 
    loop = false,
    animdirection = 1,
    flipX = 1,    
    soundstatic = false, --sounds are lowered by distance except if static is set true
    alpha = 1,
    mounts = {}, --a table key, value with mounted objects, 
    
    animationStateEnd = function() end


}
lovease.__index = lovease

local __animations =  {}
local __images =  {}



-- Local function
local check_descriptor_integrity = function(desc)
	-- @TODO
end

--

--load an image from a frame
function lovease.loadimage( filepath, framenumber, scalefactor )
    if __images[filepath] then
        if __images[filepath][framenumber] then 
            __images.__objects = __images.__objects and __images.__objects + 1 or 1
            return __images[filepath][framenumber]
        end
    end


    local sprite = aseprite.load(filepath,framenumber)

    local scale = scalefactor or nil
    -- size
    local width = sprite.width
    local height = sprite.height

    for k, layer in ipairs(sprite.layers) do
        if layer.name == "userdata" then layer.visible = false end
        if layer.name == "sound" then layer.visible = false end
        if layer.name == "static" then layer.visible = false end
        if layer.name == "hotspot" then layer.visible = false end
        if layer.name == "mount" then layer.visible = false end
    end
    
    local oldcanvas = love.graphics.getCanvas()
    local canvas
    --if not sprite.singlelayer then
    canvas = love.graphics.newCanvas(sprite.width, sprite.height)
    canvas:setFilter("nearest","nearest")
    love.graphics.setCanvas(canvas)
    --end
    

    for k, framedata in ipairs(sprite.frames[framenumber].data) do
        if sprite.layers[framedata.layer_index].visible then
            local buffer = love.data.decompress("data", "zlib", framedata.image)
            local data = love.image.newImageData(framedata.width, 
                                                 framedata.height, "rgba8", buffer)
                                             
            local image = love.graphics.newImage(data)
            local opacity = framedata.opacity / 255
            love.graphics.setColor(1,1,1,opacity)
            love.graphics.draw(image, framedata.x, framedata.y )
        end
    end

    if scale then
        local scalecanvas = love.graphics.newCanvas(width* scale, height *scale )
        love.graphics.setCanvas(scalecanvas)
        love.graphics.draw(canvas,1,1, nil, scale, scale)
        love.graphics.setCanvas(oldcanvas)
        canvas = scalecanvas
    end
    
    
    
    love.graphics.setCanvas(oldcanvas)
    

    
    __images[filepath] = {}
    __images[filepath][framenumber] = canvas
    __images.__counter = __images.__counter and __images.__counter + 1 or 1
    __images.__objects = __images.__objects and __images.__objects + 1 or 1
    return __images[filepath][framenumber]
end


function lovease:spriteload(dir, layertable)

    local sprite = aseprite.load(dir)

	-- size
	self.width = sprite.width
	self.height = sprite.height
    --self.width = scale and self.width * scale or self.width
    --self.height = scale and self.height * scale or self.height


    for k, layer in ipairs(sprite.layers) do
        if layer.name == "userdata" then layer.visible = false end
        if layer.name == "sound" then layer.visible = false end
        if layer.name == "static" then layer.visible = false end
        if layer.name == "hotspot" then layer.visible = false end
        if layer.name == "mount" then layer.visible = false end
    end
        

        -------------------tags -------------------
    for i, tag in pairs(sprite.tags) do
        local newtag = {}
        newtag.to = tag.to + 1
        newtag.from = tag.from + 1
        newtag.frames = tag.to - tag.from
        local animtype = { "normal","reverse","pingpong" }
        newtag.type = animtype[ tag.loop + 1 ]  --0 normal, 1 reverse, 2 ping - pong
        newtag.flipped = 1
        --newtag.loop = tag.name == "idle" and true or false --defaul idle loop true
        newtag.name = tag.name
        self.tags[newtag.name] = newtag
    end


	for currentframe, frame in ipairs(sprite.frames) do
        
        --check if we are in tags
        if not self:frameintag(currentframe) then next(sprite.frames) end
        
        local canvas -- used to add to as frame image
        

        canvas = love.graphics.newCanvas(self.width, self.height)
        love.graphics.setCanvas(canvas)
        --end
        

        local nextstate = nil
        local action
        local sound = nil --for sound effects
        local hotspot = nil
        --each frame has a mounts table with data for each mount set in frames
        local mounts = {}
        for _, framedata in ipairs(frame.data) do
                
            -------------------image -------------------
            local datakey, datavalue
            if framedata.userdata then
                framedata.userdata.text = string.gsub(framedata.userdata.text," " , "")
                local i = string.find(framedata.userdata.text  ,"=")
                if i then 
                    datakey = string.sub(framedata.userdata.text, 1, i -1 ) 
                    datavalue = string.sub(framedata.userdata.text, i + 1 ) 
                    datavalue = string.gsub(datavalue,"\"","")
                end
            end
            
            --a layer with this name defines hotsposts used from pencil.
            --i don't need to add this to the frame but to save them for later use
            if sprite.layers[framedata.layer_index].name == "hotspot" then
                if datakey == "hotspot" then
                    hotspot = {}
                    hotspot.x = framedata.x
                    hotspot.y = framedata.y
                    hotspot.width = framedata.width
                    hotspot.height = framedata.height
                    hotspot.name = datavalue
                    self.hotspots[hotspot.name] = hotspot
                end
            end
        
            if sprite.layers[framedata.layer_index].name == "sound" then
                if datakey == "sound" then
                    sound = {}
                    sound.type = "relative"
                    sound.name = datavalue
                end
            end
            
            if sprite.layers[framedata.layer_index].name == "static" then
                if datakey == "sound" then
                    sound = {}
                    sound.type = "static"
                    sound.name = datavalue
                end
            end
            
            if sprite.layers[framedata.layer_index].name == "userdata" then
                if datakey == "nextstate" then
                    nextstate = datavalue 
                elseif datakey == "action" then
                    action = datavalue 
                end
            end

            
            --this layer defines mountpoints
            --the mount name set on the cell as mount="mountname"
            --mounts are added to frame properties as they can change position frame by frame.
            --if string.sub(layers[framedata.data.layer_index+1].name,1,3) == "mount" then
            if sprite.layers[framedata.layer_index].name == "mount" then
                if datakey == "mount" then
                    local newmount = {}
                    newmount.x,newmount.y,
                    newmount.width,newmount.height = framedata.x, framedata.y, 
                                                     framedata.width, framedata.height
                    mounts[datavalue] = newmount
                end
            end
       
            
            -- draw only visible layers.. so handy
            if sprite.layers[framedata.layer_index].visible then
                
                local draw = true
                if layertable then
                    --checks on layer table for a deny or allow to draw, default draw
                    draw = layertable[sprite.layers[framedata.layer_index].name]
                    if draw == nil then draw = true end
                end
                
                if draw then
                    local buffer = love.data.decompress("data", "zlib", framedata.image)
                    local data = love.image.newImageData(framedata.width, framedata.height, "rgba8", buffer)
                    local image = love.graphics.newImage(data)
                    local opacity = framedata.opacity / 255
                    love.graphics.setColor(1,1,1,opacity)
                    love.graphics.draw(image, framedata.x, framedata.y )
                    --because of opacity we must draw the layer
                    --so remove singlelayer proc ? 
--                    if sprite.singlelayer  then
--                        canvas = image
--                        frameoffset.x, frameoffset.y = framedata.x , framedata.y 
--                        --set x and y as additional offset to use when drawing
--                    else
                        -- frame images can be of different sizes
                        -- but never bigger than the header width and height               

--                    end

                end
            end

        end

        if not canvas then
            canvas = love.graphics.newCanvas(sprite.width, sprite.height)
        end
        canvas:setFilter('nearest','nearest')
        
        -- finally add everything to the frame --
        table.insert(self.frames, {
        image = canvas,
        duration = frame.frame_duration / 1000,
        sound = sound or nil, 
        mounts = mounts or nil,
        nextstate = nextstate ~= nil and nextstate or nil,
        action = action ~= nil and action or nil} )

        love.graphics.setCanvas()
    end

--dump it!
end

--clears __animations and __images table
function lovease.clear()
    __animations =  {} 
    __images = {} --setmetatable( {}, {__mode="v"} ) 
end



function lovease.new(filepath, scale, animationtype, layers )
    scale = scale or 1
	local new_anim = {}
    local layeranimation = layers and layers.name or "main"
    if __animations[filepath] and __animations[filepath][layeranimation] then 
        new_anim = __animations[filepath][layeranimation]:clone()
        __animations.__objects = __animations.__objects and __animations.__objects + 1 or 1
        return new_anim
    end
    
    
	setmetatable(new_anim, lovease)
    
    new_anim.mounts = { } --setmetatable( {}, { __mode = 'k' } ) 
    new_anim.hotspots = { } --setmetatable( {}, { __mode = 'k' } ) 
    new_anim._stateEndCallbacks = {}
    new_anim._stateStartCallbacks = {}
    new_anim.tags = { } --setmetatable( {}, { __mode = 'k' } ) 
    new_anim.frames ={ } --setmetatable( {}, { __mode = 'k' } ) 
    new_anim.sounds = {}
    new_anim.scaleX = scale
    new_anim.scaleY = scale
    new_anim.type = animationtype or "relative"
    new_anim.filepath = filepath

	new_anim:init(filepath, scale, layers)
    
    __animations[filepath] = {}
    if layers then
        __animations[filepath][layers.name] = new_anim
    else
        __animations[filepath]["main"] = new_anim
    end
    
    __animations.__counter = __animations.__counter and __animations.__counter + 1 or 1
    __animations.__objects = __animations.__objects and __animations.__objects + 1 or 1

	return new_anim
end

function lovease:init( filepath, scale, layers )

    --local realdir = love.filesystem.getRealDirectory( imagePath )
    --realdir = realdir .. imagePath

    self:spriteload(filepath, layers) --realdir, scale)
    self:resetAnimation()
    
end

--
-- @brief Clones the animation (avoids reloading)
-- @return the new animation object
--
function lovease:clone()
	local new_anim = {}
	setmetatable( new_anim, lovease )
    new_anim.mounts = self.mounts
    new_anim.hotspots = self.hotspots
    new_anim.sounds = {} --self.sounds -- sounds must be remade to point to new cloned sources
    new_anim.tags = self.tags 
    new_anim.frames = self.frames
    new_anim.scaleX = self.scaleX
    new_anim.scaleY = self.scaleY
    new_anim.filepath = self.filepath

    new_anim._stateEndCallbacks = {}
    new_anim._stateStartCallbacks = {}
    new_anim.width = self.width
    new_anim.height = self.height   
    new_anim.type = self.type

    
	new_anim:resetAnimation()
	return new_anim
end

--
-- @brief Updates the animation state and frame. Called in the update loop
-- @param dt the elapsed time in seconds (floating point)
--
function lovease:update(dt)
	if self.visible == false  or not self.active then
		return -- paused
	end
    
    local lil = self.frames[self.currentFrame].mounts
     if lil then
         for name,v in pairs(lil) do
            if self.mounts[name] then
                self.mounts[name].animation:update(dt)
            end
        end
     end


	local tag = self.tags[self.currentState]

	self.tick = self.tick + dt * self.speedMultiplier
  
  
	if (tag.to - tag.from) == 0  and not lovease:iscompleted() then
        self:stateEndCall(self.currentState)
        --self.active = false --only case i use active,
        --backfires in case of mounts...

    else
    if self.tick >= self.frames[self.currentFrame].duration then
    
    --play sound
      if self.frames[self.currentFrame].sound then
            self:soundplay(self.frames[self.currentFrame].sound )
      end
      
        --execute action they are meant for battle.
      if self.frames[self.currentFrame].action and self.action then
          self:action()
            --self:soundplay(self.frames[self.currentFrame].sound )
      end
    
      -- switch to the next frame
      self.currentFrame = self.currentFrame + self.animdirection 
      
      local a = self.currentFrame > tag.to
   
      a = self.animdirection < 0 and self.currentFrame < tag.from or a
      


      
      if a then -- the animation is over

                if type(self.loop) == "number" then
                    if self.loop <= 0 then
                        self:stateEndCall(self.currentState)
                        --if self._stateEndCallbacks[self.currentState] then
                           --local lil = self._stateEndCallbacks[self.currentState]
                            --lil.call(lil.receiver, self.currentState )
                            --self._stateEndCallbacks[self.currentState] = nil
                        --end
                    end
                else
                    self:stateEndCall(self.currentState)

                    --if self._stateEndCallbacks[self.currentState] then
                    --    local lil = self._stateEndCallbacks[self.currentState]
                    --    lil.call(lil.receiver, self.currentState )
                    --    self._stateEndCallbacks[self.currentState] = nil
                    --end
                   --events[self.uid].completed = true 
                end
            --end 
        --end
            
        self.currentFrame = tag.to -- next state is always on last frame
        if not self.frames[self.currentFrame].nextstate  then
          if tag.type == "pingpong" then
            self.animdirection = self.animdirection * -1
            self.currentFrame = self.animdirection > 0 and tag.from or tag.to
     
          elseif tag.type == "normal" or tag.type == "reverse"  then
                self.completed = self.currentState
                
                self.animdirection = tag.type == "normal" and 1 or -1
                local  startframe = tag.type == "normal" and tag.from  or tag.to 
                local  endframe = tag.type == "normal" and tag.to or tag.from  
                
              if type(self.loop) == "boolean" then
                --self.currentFrame = self.loop and tag.from or tag.to 
                self.currentFrame = self.loop and startframe or endframe 

              elseif type(self.loop) == "number"  then
                self.loop = self.loop > 0 and self.loop -1 or 0
                if self.loop == 0 then 
                    --self.tags[self.currentState].completed = true 
                    self.completed = self.currentState
                end  --for actions to check
                if self.loop <= 0 then 
                  self.currentFrame = endframe --tag.to 
                else
                  self.currentFrame = startframe --tag.from 
                end
                  
              end
              
            
          end
          
            self.tick = 0
          return
        end
        
        local nexstate = self.frames[self.currentFrame].nextstate
        if nexstate then
            --callbacks
            if nexstate ~= self.currentState then
                self:stateEndCall(self.currentState)
              --if self._stateEndCallbacks[self.currentState] then
              --      local lil = self._stateEndCallbacks[self.currentState]
              --      lil.call(lil.receiver, self.currentState )
              --      self._stateEndCallbacks[self.currentState] = nil
              --end
              if self._stateStartCallbacks[nexstate] then
                self._stateStartCallbacks[nexstate](self, nexstate)
              end

            end
      
            self.currentState = nexstate
            self.currentFrame = self.tags[self.currentState].from
            
        end
      end
      -- reset tick
      self.tick = 0

    end
  end


end

--
-- @brief Draws the sprite on the screen. Called in the drawing loop
--
--
function lovease:draw() --scalex, scaley)
    --local scaleX = scalex and scalex or self.scaleX
    --local scaleY = scaley and scaley or self.scaleY
    local scaleX = self.scaleX
    local scaleY = self.scaleY


    --if tag.to and tag.from are the same just set completed after draw
    local tag = self.tags[self.currentState]
    if tag.to == tag.from  then
        if self.uid then
            if events[self.uid] then 
                events[self.uid].completed = true 
            end 
        end  
    end


	if not self.visible then
		return
	end
    
   local newflipX = self.tags[self.currentState].flipped * scaleX 
   
   --[[
    if self.type == "relative" then
        if self.hotspots["feet"] then 
            self.relativeOriginX = self.hotspots["feet"].x 
            self.relativeOriginY = self.hotspots["feet"].y  
        else
        --image position is the horizontal center and the bottom
            self.relativeOriginX = self.width / 2  
            self.relativeOriginY = self.height 
        end
    end
    --]]
    

    if self.filter then
        self.frames[ self.currentFrame].image:setFilter(self.filter,self.filter)
    end
   
    local color = { love.graphics:getColor() }
    --apply alpha
    love.graphics.setColor(color[1],color[2],color[3],self.alpha)
   
   
    if self.effect and self.effect.name == "tint" then
        love.graphics.setColor(self.effect.color)
    end
        
	love.graphics.draw(self.frames[ self.currentFrame].image,
		self.x , 
		self.y ,
		self.rotation,
		newflipX, --self.flipX * (scaleX or 1), -- negative scale to flip
		scaleY or 1, -- scale
		self.relativeOriginX  ,
		self.relativeOriginY  , 
		0,0)
    
    --reset color
    if self.effect and self.effect.name == "tint" then
        love.graphics.setColor(color)
    end
    
    if self.effect then
        if self.effect.name == "blink" then
            love.graphics.setBlendMode("add", "alphamultiply")
            --love.graphics.setBlendMode("multiply", "premultiplied")
            --local newcolor = shallowcopy(colors.blinkcolor.gold)
            --newcolor[1] = 1 - newcolor[1]
            --newcolor[2] = 1 - newcolor[2]
            --newcolor[3]= 1 - newcolor[3]

            love.graphics.setColor(self.effect.color)
            --love.graphics.rectangle("fill", self.x ,self.x, self.width, self.height )
            love.graphics.draw(self.frames[ self.currentFrame].image,
            self.x , 
            self.y ,
            self.rotation,
            newflipX, --self.flipX * (scaleX or 1), -- negative scale to flip
            scaleY or 1, -- scale
            self.relativeOriginX  , 
            self.relativeOriginY  , 
            0,0)
            love.graphics.setBlendMode("alpha")
            love.graphics.setColor(color)
        end
    end
    
     --draw mounted objects
     local lil = self.frames[self.currentFrame].mounts
     if lil then
        local x,y = self:getGeometry() 
        for name,v in pairs(lil) do
            if self.mounts[name] then

                self.mounts[name].animation.x = x + v.x * self.scaleX
                self.mounts[name].animation.y = y + v.y * self.scaleY
                self.mounts[name].animation:draw()
            end
        end
        
     end
     
    love.graphics.setColor(color)
end

--
-- @brief Sets the state of the animation
-- @param state (string) a state specified in the animation file that we want to switch to
-- e.g anim:setState("jump")
--
-- loop can be bool or number too to specify how many time to cicle
function lovease:setState(state, loop , flipped, force)
    loop = loop or false
  --change animation only if is different
	local current = self.currentState
    
   
  --if state == current and self.tags[state].loop == loop then return end

  if state == current and  self.loop ==  loop and not force then return end
  assert(self.tags[state],"missing animation tag : "..state .. " " .. self.filepath)
    
	if self.tags[state] then

        
		if state ~= current or ( state == current and force ) then
            self.active = true 
            self:stateEndCall(self.currentState)
            --if self._stateEndCallbacks[self.currentState] then
            --   local lil = self._stateEndCallbacks[self.currentState]
            --    lil.call(lil.receiver, self.currentState )
            --    self._stateEndCallbacks[self.currentState] = nil
            --end
			if self._stateStartCallbacks[state] then
				--self._stateStartCallbacks[state](self, state)
			end
		end
--    if self.descriptor.states[state].clone  then
 --     state = self.descriptor.states[state].clone
  --  end

      
    self.currentState = state
    self.tick = 0
       
    self.tags[state].flipped = flipped and flipped  or self.tags[state].flipped
    self.loop = loop
        if self.tags[state].type == "reverse" then
            self.animdirection = -1
            self.currentFrame = self.tags[self.currentState].to
        else
            self.animdirection = 1
          self.currentFrame = self.tags[self.currentState].from
        end
		--self.currentFrame = self.tags[self.currentState].from
	end

end

--
-- @brief Gets the state the animation is currently in
-- @return (string) the current state
--
function lovease:getCurrentState()
    local loop = self.loop
	return self.currentState,loop,self.currentFrame
end

--
-- @brief Gets the list of all states
-- @return (array) the list of all possible states
--
function lovease:getAllStates()
	local states = {}
	for state in pairs(self.descriptor.states) do
		table.insert(states, state)
	end
	return states
end

--
-- @brief Sets the frame of the animation state
-- @param f (integer) the frame number
--
function lovease:setCurrentFrame(f)
    if self.frames[f] then
		self.currentFrame = f
	end
end
function lovease:getCurrentFrame()
		return self.currentFrame 
end

--
-- @brief Allows to speed up the animation with a multiplier
-- @param sm (positive floating point) the multiplier
--
function lovease:setSpeedMultiplier(sm)
	-- negative multiplier support ? backwards animations ? to think abt it
	self.speedMultiplier = math.abs(sm)
end

--
-- @brief Returns the animation to it's inital state,frame,speed,rotation
--
--
function lovease:resetAnimation()
	self.currentState =  self.defaultState
	self.tick = 0
	self.speedMultiplier = 1
	self.active = true
	self.currentFrame = self.tags[self.currentState].from
	self.rotation = 0
    self.animdirection = 1
    self.completed = nil
    self:settype(self.type)
end
function lovease:resetState()
	--self.currentState =  self.defaultState
	self.tick = 0
	self.speedMultiplier = 1
	self.active = true
	self.currentFrame = self.tags[self.currentState].from
	self.rotation = 0
    self.animdirection = 1
    self.completed = nil
end

local _CheckCollision = function(ax1,ay1,aw,ah, bx1,by1,bw,bh)
  local ax2,ay2,bx2,by2 = ax1 + aw, ay1 + ah, bx1 + bw, by1 + bh
  return ax1 < bx2 and ax2 > bx1 and ay1 < by2 and ay2 > by1
end

--
-- @brief Checks for a collision between the sprite quad and the specified rectangle
-- @return true if the two quads intersect, false otherwise
--
function lovease:intersects(x,y,width,height)
	local h = height or 1
	local w = width or 1
	local state_descriptor = self.descriptor.states[self.currentState]

	return _CheckCollision(
		self.x - (self.relativeOriginX * state_descriptor.frameW),
		self.y - (self.relativeOriginY * state_descriptor.frameH),
		state_descriptor.frameW,
		state_descriptor.frameH,
		x,y,w,h
	)
end

--
-- @brief Switches the pause
--
--
function lovease:togglePause()
	self.active = not self.active
end

--
-- @brief Pauses the animation
--
--
function lovease:pause()
  --local pauseframe = self.tags[self.currentState].pauseframe
  --if pauseframe then 
  --  self:setCurrentFrame(pauseframe)
  --end
	self.active = false
end

--
-- @brief Unpauses the animation
--
--
function lovease:unpause()
	self.active = true
end

--
-- @brief Get the sprite's current position and size
--
function  lovease:getGeometry()
    
	--return 	self.x,  self.y,  self.width, self.height --self:getFrameWidth(),  self:getFrameHeight()
    local x, y , width, height
 
    if self.type == "relative" or self.type == "center" then
        x = self.x - self.relativeOriginX * self.scaleX
        y = self.y - self.relativeOriginY * self.scaleY
        
    else
        x = self.x 
        y = self.y 
    end
       
    
    width = self.width * self.scaleX
    height = self.height * self.scaleY
    
    return x , y, width, height
end

function  lovease:getPosition()
    local x, y
    if self.type == "relative" then
        x, y = self.x, self.y -- - self.relativeOriginX , self.y - self.relativeOriginY
    else

        x, y = self.x, self.y
    end
    
	return x, y
end

function  lovease:getBox()
  
  
	return self.descriptor.bw,  self.descriptor.bh
end

--
-- @brief Sets the sprite's current position
-- @param x the x coordinate of the sprite
-- @param y the y coordinate of the sprite
--
function  lovease:setPosition(x, y)
	self.x = x
	self.y = y
end

--
-- @brief Rotates the sprite to the specified angle
-- @param r rotation angle (according to the love drawing functions)
--
function  lovease:setRotation(r)
	self.rotation = r
end

--
-- @brief Sets the sprite as visible or invisible
-- @param v (bool) true if visible, false if invisible
--
function  lovease:setVisibility(v)
	self.visible = v
end

--
-- @brief Sets the origin of the sprite (default is top left corner)
-- @param ox the x coordinate
-- @param oy the y coordinate
--
-- The coordinates are a percentage relative to the sprite.
-- e.g : setRelativeOrigin(0,0) is the top left corner
-- e.g : setRelativeOrigin(0.5,0.5) is the center of the sprite
--
function lovease:setRelativeOrigin(ox, oy)
	-- rename to setAnchorPoint (perhaps clearer)
	self.relativeOriginX = ox
	self.relativeOriginY = oy
end

--
-- @brief Flips the sprite horizontally
--
-- attention : the flips is dependant on the origin
--
function lovease:toggleHorizontalFlip()
	self.flipX = -1 * self.flipX
end

--
-- @brief Flips the sprite horizontally according to bool
-- @param bool (bool) true if the sprite should be flipped horizontally
--
-- attention : the flips is dependant on the origin
--
function lovease:setHorizontalFlip(bool)
        self.flipX = bool and -1 or 1
end

--
-- @brief Gets the width of the current frame
-- @return the current width
--
function lovease:getFrameWidth()
	return self.width
end

--
-- @brief Gets the height of the current frame
-- @return the current height
--
function lovease:getFrameHeight()
	return self.height
end

--
-- @brief Gets width & height of the current frame
-- @return current dimension
--
function lovease:getFrameDimension()
	local state_descriptor = self.descriptor.states[self.currentState]
	return state_descriptor.frameW, state_descriptor.frameH
end
--
-- EVENTS
--

--
-- @brief Adds a listener to the animation. Called when the last frame of a state is reached
-- @param state (string) The name of the state
-- @param callback (function) The callback function, recieves the lovease object as param
-- Set the callback to nil to stop receiving events
--
function lovease:onStateEnd(state, receiver, func, delete )
    --there might be more listeners so let's add them all to the table
    
    --delete =  if true we delete the listener after sending the notification
    if not self._stateEndCallbacks[state] then
        self._stateEndCallbacks[state] = {}
    end
    
    -- table is the key
    local listener = tostring(receiver)

    --if function is nil remove the receiver
    local lil = self._stateEndCallbacks[state] 
    lil[listener] = func and {receiver = receiver, call = func, delete = delete and delete or false } or nil

end
function lovease:stateEndCall(state )
    if not self._stateEndCallbacks[state] then return end

    local lil = self._stateEndCallbacks[state]
    for k,v in pairs(self._stateEndCallbacks[state]) do

        v.call(v.receiver, state )
        --delete listener
        if v.delete then 
            lil[k] = nil 
        end
    end

    --self._stateEndCallbacks[self.currentState] = nil
end
                        
--
-- @brief Adds a listener to the animation. Called when the state starts
-- @param state (string) The name of the state
-- @param callback (function) The callback function, recieves the lovease object as param
-- Set the callback to nil to stop receiving events
--
function lovease:onStateStart(state, callback)
	self._stateStartCallbacks[state] = callback
end

function lovease:soundplay(sound)
    --create the sound source if not present

    self.sounds[sound.name] = self.sounds[sound.name] or audio:new(sound.name)

    if sound.type == "static" then 
        self.sounds[sound.name]:attenuate(false)
        self.sounds[sound.name]:play() 
    elseif sound.type == "relative" then
        _ = not self.sounds[sound.name].attenuation and self.sounds[sound.name]:attenuate(true) 
        self.sounds[sound.name]:play(nil,self)  
    end
end



function lovease:getBoxPosition(x,y)
    local bx,by     
    bx = x - self.width / 2 - self.bofx
    by = y -  self.height - self.bofy
    return bx, by
end


function lovease:getDrawPosition()

    return self.drawx, self.drawy
end

--coordinates are absolute
function lovease:getHotSpotCoords(hotspotname)
    local x,y,width, height
    width = self.hotspots[hotspotname].width  * self.scaleX
    height = self.hotspots[hotspotname].height * self.scaleY
    
    if self.type == "relative" then

        if self.tags[self.currentState].flipped == 1 then
        
            x = self.x - ( self.relativeOriginX * self.scaleX  ) +             
                         ( self.hotspots[hotspotname].x * self.scaleX )
            y = self.y - (self.relativeOriginY * self.scaleY) +  
                         ( self.hotspots[hotspotname].y * self.scaleY )
        else
            
            x = self.x + ( self.relativeOriginX * self.scaleX  ) -  
                         ( self.hotspots[hotspotname].x * self.scaleX ) - width
            y = self.y - (self.relativeOriginY * self.scaleY) +  
                         ( self.hotspots[hotspotname].y * self.scaleY ) 

        end
                 
    elseif self.type == "center" then
        x = self.x + self.relativeOriginX + self.hotspots[hotspotname].x *
                    self.scaleX * self.tags[self.currentState].flipped
        y = self.y + self.relativeOriginY  + self.hotspots[hotspotname].y * self.scaleY 
    else
     
        x = self.x + self.hotspots[hotspotname].x * self.scaleX * self.tags[self.currentState].flipped
        y = self.y + self.hotspots[hotspotname].y * self.scaleY 

    end
       
    return x, y, width, height
end

--coordinates are relative to animation,  used for bump
function lovease:getHotSpotGeometry(hotspotname)
    local x, y, width, height
    width = self.hotspots[hotspotname].width  * self.scaleX
    height = self.hotspots[hotspotname].height * self.scaleY

    if self.type == "relative" then
        
        if self.tags[self.currentState].flipped == 1 then
            x = ( self.hotspots[hotspotname].x * self.scaleX ) - ( self.relativeOriginX * self.scaleX  )  
            y = ( self.hotspots[hotspotname].y * self.scaleY ) - ( self.relativeOriginY * self.scaleY  ) 
                
        else
            x = ( self.hotspots[hotspotname].x * self.scaleX ) - ( self.relativeOriginX * self.scaleX  )  
            y = ( self.hotspots[hotspotname].y * self.scaleY ) - ( self.relativeOriginY * self.scaleY  ) 
            
        end
            
    else
        x = self.hotspots[hotspotname].x * self.scaleX --* self.tags[self.currentState].flipped
        y = self.hotspots[hotspotname].y * self.scaleY
    end


    return x, y, width, height
end


function lovease:iscompleted()
    if self.completed == self.currentState then return true else return false end
    --return self.tags[self.currentState].completed or false
end


function lovease:copyGeometry(target)
    target.animation.x = self.x
    target.animation.y = self.y
    target.animation.widht = self.width
    target.animation.height = self.height
end


function lovease:getAnimationflags()
    return self.loop, self.tags[self.currentState].flipped
end

function lovease:frameintag(frame)
    for k, tag in pairs(self.tags) do
        if frame >= tag.from and frame <= tag.to then
            return k
        end
    end
    return false
end

function lovease:settype(type)
    self.type = type
    if self.type == "relative" then
        if self.hotspots["feet"] then 
            self.relativeOriginX = self.hotspots["feet"].x 
            self.relativeOriginY = self.hotspots["feet"].y  
        else
            --image position is the horizontal center and the bottom
            self.relativeOriginX = self.width / 2  
            self.relativeOriginY = self.height 
        end
        
    elseif self.type == "normal" then
            self.relativeOriginX = 1 
            self.relativeOriginY = 1
    elseif self.type == "center" then
            self.relativeOriginX = self.width / 2
            self.relativeOriginY = self.height / 2
    end
end

function lovease:countweaktables()
    loginfo:print("Total Images ",  __images.__counter, __images.__objects  )
    loginfo:print("Total Animations ", __animations.__counter , __animations.__objects )

    for k,v in pairs(__images) do
        loginfo:print("image " .. k )
    end
        for k,v in pairs(__animations) do
        loginfo:print("animation " .. k )
    end
    

end

